import { http } from '~/assets/ts/services/httpClient';

import { AppointmentLog } from '../models/appointment.model';

// 取得所有預約清單
export function getMyAppointmentList():Promise<ClientInfo[]> {
    const headers = {
        Authorization: 'Bearer ' + localStorage.getItem('id_token')
    }
    return http.get('/consultant/getMyAppointment', {headers}).then(res => res.data);
}

// 標記為已聯絡
export function markAsContact(appointmentId: number) {
    const headers = {
        Authorization: 'Bearer ' + localStorage.getItem('id_token')
    }
    // TODO: 跟後端確認，這裡的 API 不應該傳回 void, 而是應該是更新後的資料 - Ben 2021/11/16
    return http.post('/appointment/markAsContacted/'+appointmentId, undefined, {headers})
            .then(res => res.data)
}

export function getMyReviewLog(): Promise<AppointmentLog[]> {
    const headers = {
        Authorization: 'Bearer ' + localStorage.getItem('id_token')
    }
    return http.get('/satisfaction/getMySatisfaction', { headers }).then(res => res.data);
}


// 顧問登入顯示新預約單筆數後觸發
export function allAppointmentsView() {
    const headers = {
        Authorization: 'Bearer ' + localStorage.getItem('id_token')
    }
    return http.post('/consultant/record/allAppointmentsView', undefined, {headers})
}

// 讀取預約單時觸發
export function recordRead(appointmentId: number) {
    const headers = {
        Authorization: 'Bearer ' + localStorage.getItem('id_token')
    }
    return http.post('/appointment/recordRead/' + appointmentId, undefined, {headers})
}


export interface ClientInfo {
    id               : number,
    phone            : string,
    email            : string,
    contactType      : string,
    gender           : string,
    age              : string,
    job              : string,
    requirement      : string,
    communicateStatus: string,
    hopeContactTime  : string,
    otherRequirement : string,
    appointmentDate  : Date,
    agentNo          : string,
    customerId       : number,
    name             : string,
    consultantViewTime: Date,
    consultantReadTime: Date,
    contactTime      : Date,
    satisfactionScore: number
}
